// keyboard.h
// Plato Keyboard Driver
// Part of Plato OS

#include "irq.h"        // IRQ Methods
#include "prototypes.h"    // Function Prototypes
#include "keybdef.h"     // Scancode Defines

#define newline (char *)0xA
#define bell    (char *)0x7

byte scancode = inb(0x60);

void ReadUntilEnter()                      // Read, interpret, and print the scancode, until ENTER is pressed
{
	while(scancode != enter) {         // This is supposed to wait for ENTER, but GCC says that it's always false
	scancode = inb(0x60);
	        if(scancode == q)   { printf("q");   }
		if(scancode == w)   { printf("w");   }
		if(scancode == e)   { printf("e");   }
		if(scancode == r)   { printf("r");   }
		if(scancode == t)   { printf("t");   }
		if(scancode == y)   { printf("y");   }
		if(scancode == u)   { printf("u");   }
		if(scancode == i)   { printf("i");   }
		if(scancode == o)   { printf("o");   }
		if(scancode == p)   { printf("p");   }
		if(scancode == a)   { printf("a");   }
		if(scancode == s)   { printf("s");   }
		if(scancode == d)   { printf("d");   }
		if(scancode == f)   { printf("f");   }
		if(scancode == g)   { printf("g");   }
		if(scancode == h)   { printf("h");   }
		if(scancode == j)   { printf("j");   }
		if(scancode == k)   { printf("k");   }
		if(scancode == l)   { printf("l");   }
		if(scancode == z)   { printf("z");   }
		if(scancode == x)   { printf("x");   }
		if(scancode == c)   { printf("c");   }
		if(scancode == v)   { printf("v");   }
		if(scancode == b)   { printf("b");   }
		if(scancode == n)   { printf("n");   }
		if(scancode == m)   { printf("m");   }

		if(scancode == f1)  { help();      wait(10000000);   }
		if(scancode == f2)  { longabout(); wait(10000000);   }
		if(scancode == f3)  { wait(100000);  }
		if(scancode == f4)  { printf("F4");  }
		if(scancode == f5)  { printf("F5");  }
		if(scancode == f6)  { printf("F6");  }
		if(scancode == f7)  { printf("F7");  }
		if(scancode == f8)  { printf("F8");  }
		if(scancode == f9)  { printf("F9");  }
		if(scancode == f10) { printf("F10"); }
		if(scancode == f11) { printf("F11"); }
		if(scancode == f12) { printf("F12"); }

		if(scancode == enter)  { printf("%c",newline); }
		if(scancode == space)  { printf(" ");  }
		if(scancode == l_alt)  { printf("&/"); }
		if(scancode == r_alt)  { printf("^/"); }
		if(scancode == l_ctrl) { printf("$/"); }
		if(scancode == r_ctrl) { printf("*/"); }
		if(scancode == esc)    { redrawMain(); }
		if(scancode == backspace) { printf("%c",(char *)0x7f); }

		if(scancode == r_bracket)   { printf("]");  }
		if(scancode == l_bracket)   { printf("[");  }
		if(scancode == backslash)   { printf("\\"); }
		if(scancode == apostrophe)  { printf("'");  }
		if(scancode == semicolon)   { printf(";");  }
		if(scancode == period)      { printf(".");  }
		if(scancode == comma)       { printf(",");  }
		if(scancode == frontslash)  { printf("/");  }
		if(scancode == grave)       { printf("`");  }

		else                { /* Ignore it */ }

		scancode = 0x00;
	        outb(0x20,0x20);
	}
}
